<?php

function deleteRecords($taryear,$die = true) {
  global $wpdb;
  $curyear = date("Y");
  if (isset($taryear)) {
      $value = $taryear;
      if (is_numeric($value) && $value >= 2000 && $value <= $curyear) {
          $year = $value;
      } else {
          die("Fail: Valid year required, between 2000 and ".$curyear);
      }
  } else {
      $year = $curyear;
  }
  $table = $wpdb->prefix . "sharelink";
  $query = "DELETE FROM ".$table." WHERE date LIKE \"".$year."%\"";
  $wpdb->query($query);
  $dir = 'wp-content/sharelink/';
  chdir($dir);
  $files = glob($year."*.pdf");
  if (!$files) {
      $message = "No records for $year";
  } else {
    foreach ($files as $filename) {
        echo $filename . "</br>";
        unlink($filename);
    }
    $message = "$year records deleted";
  }

  if ($die) {
    die($message);
  } else {
    echo $message;
  }
}

if (isset($_GET["cl"])) {
    deleteRecords($_GET["cl"]);
}

if (isset($_GET["download-sharelink"])) {
    function sortFeedHelper($a, $b) {
        // Reverse sort all entries, so newest appear at the top
        // in the RSS feed. Also, new entries get processed first.
        return strcmp($b->date, $a->date);
    }

    if (get_site_option('sharelink-clear-once') == false) {
      echo 'Clearing old records once for data integrity</br>';
      deleteRecords(date('Y'),false);
      add_option('sharelink-clear-once','1');
    }

    $sharelink = new ShareLink();
    $feed = $sharelink->feedFromServer();

    usort($feed, 'sortFeedHelper');

    $license_details = $sharelink->getLicenseDetails();

    $rss_body = '<?xml version="1.0" encoding="UTF-8" ?>
<rss version="2.0" xmlns:content="http://purl.org/rss/1.0/modules/content/">
<channel>
 <title>ASX Announcements for ' . htmlspecialchars($license_details['stock']) . '</title>
 <description>ASX Announcements for ' . htmlspecialchars($license_details['stock']) . '</description>
 <link>http://' . $_SERVER['HTTP_HOST'] . '/</link>
 <lastBuildDate>' . date(DATE_RSS) . '</lastBuildDate>
 <pubDate>' . date(DATE_RSS) . '</pubDate>
 <ttl>1800</ttl>
';

    foreach ($feed as $item) {
        $title = $item['title'];
        $link = $item['url'];
        $date = $item['date'];
        $link = "http://www.asx.com.au$link";

        if ($sharelink->addArticleToDatabase($title, $link, $date)) {
            echo $title." added<br />";
        } else {
            echo $title." not added<br />";
        }

        // Add the RSS entry as well.
        $item_timestamp = DateTime::createFromFormat('d/m/Y',$date);
        $pdf_url = sprintf($link);
        $entry_body = '<p><a href="' . htmlspecialchars($pdf_url) . '">' . htmlspecialchars($title) . '</a></p>';
        $rss_body .= ' <item>
  <title>' . htmlspecialchars($title) . '</title>
  <description>' . htmlspecialchars($title) . '</description>
  <content:encoded><![CDATA['  . $entry_body . ']]></content:encoded>
  <link>' . htmlspecialchars($pdf_url) . '</link>
  <guid isPermaLink="false">' . htmlspecialchars($friendly) . '</guid>
  <pubDate>' . $item_timestamp->format(DATE_RSS) . '</pubDate>
 </item>
';
    }

    $rss_body .= '</channel>
</rss>';

    // Write out to the cache.
    $doWritePath = WP_CONTENT_DIR . "/sharelink/do-announcements.txt";
    if (file_exists($doWritePath)) {
        $rss_cache = WP_CONTENT_DIR . "/sharelink/announcements.xml";
        file_put_contents($rss_cache, $rss_body);
    }

    die("Download complete");
}
